module Necessitas
  module Configuration
    class Besse
      attr_accessor :api_key, :username, :password

      def initialize
        @api_key  =  nil
        @username =  nil
        @password =  nil
      end

      def api_endpoint=(endpoint)
        Necessitas::Connection::Besse.base_uri(endpoint.freeze)
      end

      def api_endpoint
        Necessitas::Connection::Besse.base_uri
      end

      def to_h
        {
          api_key: @api_key,
          username: @username,
          password: @password,
          api_endpoint: api_endpoint
        }
      end

      def from_h(h)
        self.api_key  = h[:api_key]
        self.username = h[:username]
        self.password = h[:password]
        self.api_endpoint = h[:api_endpoint]

        return self
      end

      def basic_auth
        {
          username: @username,
          password: @password
        }
      end

      def api_auth_header
        {
          APIKey: @api_key
        }
      end
    end
  end
end
