module Necessitas
  module Models
    module Besse
      class AccountInfo < Hashie::Trash
        include Hashie::Extensions::IgnoreUndeclared
        include Hashie::Extensions::IndifferentAccess

        property :CustomerNumber, from: :customer_number, required: false
        property :GenericEquivalents, from: :generics, default: 'N', required: false
        property :ItemInfo, from: :items, required: false, default: []

        alias_method :customer_number, :CustomerNumber

        def items
          self[:ItemInfo].map {|item_info| Necessitas::Models::Besse::Item.new(item_info) }
        end

        def generics?
          return true if 'Y' == self[:GenericEquivalents]
          return false if 'N' == self[:GenericEquivalents]

          true == self[:GenericEquivalents]
        end

        def generics=(v)
          self[:GenericEquivalents] = generics_translate(v)
        end

        def generics_translate(v)
          return 'Y' if true == v
          return 'N' if false == v

          v
        end

        def as_json(args = {})
          {
            AccountInfo: self.to_h
          }
        end
      end
    end
  end
end
