module Necessitas
  module Models
    module Besse
      class AtpResponse
        def initialize(data: nil, response: nil)
          @data = data
          @data = response.parsed_response if @data.nil? && response && response.ok?
          @data ||= {}
          @response = response
        end

        def request_id
          @data.dig('RequestSummaryInfo', 'RequestID')
        end

        def accounts
          @data.dig('AccountInfo').map do |account_info|
            Necessitas::Models::Besse::AccountInfo.new(account_info)
          end
        end

        def ok?
          return @response&.ok?
        end
      end
    end
  end
end
