module Necessitas
  module Models
    module Besse
      class OrderHeaderInfo < Hashie::Trash
        include Hashie::Extensions::IgnoreUndeclared
        include Hashie::Extensions::IndifferentAccess

        property :CustomerNumber, from: :customer_number, required: false
        property :LocationNumber, from: :location_number, required: false
        property :PurchaseOrderNumber, from: :purchase_order_number, required: false
        property :SalesOrderNumber, from: :sales_order_number, required: false
        property :CustomerShippingLabelText, from: :shipping_label_text, required: false
        property :POType, from: :po_type, required: false
        property :DeliveryBlock, from: :delivery_block, required: false
        property :DeliveryTerm, from: :delivery_term, required: false
        property :LocationNumber, from: :location_number, required: false
        property :RequestedDeliveryDate, from: :requested_delivery_date, required: false
        property :SalesDocType, from: :sales_doc_type, required: false
        property :OrderType, from: :order_type, required: false
        property :OrderSequenceId, from: :order_sequence_id, required: false
        property :OrderSequenceID, from: :order_sequence_id, required: false

        alias_method :customer_number, :CustomerNumber
        alias_method :location_number, :LocationNumber
        alias_method :purchase_order_number, :PurchaseOrderNumber
        alias_method :sales_order_number, :SalesOrderNumber
        alias_method :shipping_label_text, :CustomerShippingLabelText
        alias_method :po_type, :POType
        alias_method :delivery_block, :DeliveryBlock
        alias_method :delivery_term, :DeliveryTerm
        alias_method :location_number, :LocationNumber
        alias_method :requested_delivery_date, :RequestedDeliveryDate
        alias_method :sales_doc_type, :SalesDocType
        alias_method :order_type, :OrderType

        def to_h
          result = super.to_h

          %w[RequestedDeliveryDate].each do |k|
            result[k] = Necessitas::Connection::Besse.format_date(result[k])
          end

          result
        end

        def as_json(args = {})
          self.to_h
        end

        def order_sequence_id
          self.OrderSequenceId || self.OrderSequenceID
        end
      end
    end
  end
end
